Update photoprism-install.sh

This commit is contained in:
tteckster 2022-04-17 20:36:15 -04:00 committed by GitHub
parent 02a1d525dd
commit 5aba72533c
No known key found for this signature in database
GPG Key ID: 4AEE18F83AFDEB23
1 changed files with 44 additions and 52 deletions

View File

@ -1,37 +1,30 @@
#!/usr/bin/env bash
set -o errexit
set -o errtrace
set -o nounset
set -o pipefail
shopt -s expand_aliases
alias die='EXIT=$? LINE=$LINENO error_exit'
trap die ERR
trap 'die "Script interrupted."' INT
function error_exit() {
trap - ERR
local DEFAULT='Unknown failure occured.'
local REASON="\e[97m${1:-$DEFAULT}\e[39m"
local FLAG="\e[91m[ERROR:LXC] \e[93m$EXIT@$LINE"
msg "$FLAG $REASON"
exit $EXIT
}
function msg() {
local TEXT="$1"
echo -e "$TEXT"
}
#!/usr/bin/env bash -ex
set -euo pipefail
shopt -s inherit_errexit nullglob
YW=`echo "\033[33m"`
RD=`echo "\033[01;31m"`
BL=`echo "\033[36m"`
GN=`echo "\033[1;92m"`
CL=`echo "\033[m"`
CM="${GN}${CL}"
CROSS="${RD}${CL}"
RETRY_NUM=10
RETRY_EVERY=3
NUM=$RETRY_NUM
CM="${GN}${CL}"
CROSS="${RD}${CL}"
BFR="\\r\\033[K"
HOLD="-"
echo -en "${GN} Setting up Container OS... "
function msg_info() {
local msg="$1"
echo -ne " ${HOLD} ${YW}${msg}..."
}
function msg_ok() {
local msg="$1"
echo -e "${BFR} ${CM} ${GN}${msg}${CL}"
}
msg_info "Setting up Container OS "
sed -i "/$LANG/ s/\(^# \)//" /etc/locale.gen
locale-gen >/dev/null
while [ "$(hostname -I)" = "" ]; do
@ -44,16 +37,15 @@ while [ "$(hostname -I)" = "" ]; do
exit 1
fi
done
echo -e "${CM}${CL} \r"
echo -en "${GN} Network Connected: ${BL}$(hostname -I)${CL} "
echo -e "${CM}${CL} \r"
msg_ok "Set up Container OS"
msg_ok "Network Connected: ${BL}$(hostname -I)"
echo -en "${GN} Updating Container OS... "
msg_info "Updating Container OS"
apt update &>/dev/null
apt-get -qqy upgrade &>/dev/null
echo -e "${CM}${CL} \r"
msg_ok "Updated Container OS"
echo -en "${GN} Installing Dependencies... "
msg_info "Installing Dependencies"
apt-get install -y curl &>/dev/null
apt-get install -y sudo &>/dev/null
apt-get install -y gcc &>/dev/null
@ -63,23 +55,23 @@ apt-get install -y gnupg &>/dev/null
apt-get install -y make &>/dev/null
apt-get install -y zip &>/dev/null
apt-get install -y unzip &>/dev/null
echo -e "${CM}${CL} \r"
msg_ok "Installed Dependencies"
echo -en "${GN} Setting up Node.js Repository... "
msg_info "Setting up Node.js Repository"
sudo curl -sL https://deb.nodesource.com/setup_16.x | sudo -E bash - &>/dev/null
echo -e "${CM}${CL} \r"
msg_ok "Set up Node.js Repository"
echo -en "${GN} Installing Node.js... "
msg_info "Installing Node.js"
apt-get install -y nodejs &>/dev/null
echo -e "${CM}${CL} \r"
msg_ok "Installed Node.js"
echo -en "${GN} Installing Golang... "
msg_info "Installing Golang"
wget https://golang.org/dl/go1.18.linux-amd64.tar.gz &>/dev/null
tar -C /usr/local -xzf go1.18.linux-amd64.tar.gz &>/dev/null
ln -s /usr/local/go/bin/go /usr/local/bin/go &>/dev/null
echo -e "${CM}${CL} \r"
msg_ok "Installed Golang"
echo -en "${GN} Installing Tensorflow... "
msg_info "Installing Tensorflow"
AVX=$(grep -o -m1 'avx[^ ]*' /proc/cpuinfo)
if [[ "$AVX" == "avx2" ]]; then
wget https://dl.photoprism.org/tensorflow/linux/libtensorflow-linux-avx2-1.15.2.tar.gz &>/dev/null
@ -94,21 +86,21 @@ if [[ "$AVX" == "avx2" ]]; then
tar -C /usr/local -xzf libtensorflow-linux-cpu-1.15.2.tar.gz &>/dev/null
ldconfig &>/dev/null
fi
echo -e "${CM}${CL} \r"
msg_ok "Installed Tensorflow"
echo -en "${GN} Cloning PhotoPrism... "
msg_info "Cloning PhotoPrism"
mkdir -p /opt/photoprism/bin
mkdir /var/lib/photoprism
git clone https://github.com/photoprism/photoprism.git &>/dev/null
cd photoprism
git checkout release &>/dev/null
echo -e "${CM}${CL} \r"
msg_ok "Cloned PhotoPrism"
echo -en "${GN} Building PhotoPrism... "
msg_info "Building PhotoPrism"
make all &>/dev/null
./scripts/build.sh prod /opt/photoprism/bin/photoprism &>/dev/null
cp -a assets/ /opt/photoprism/assets/ &>/dev/null
echo -e "${CM}${CL} \r"
msg_ok "Built PhotoPrism"
env_path="/var/lib/photoprism/.env"
echo "
@ -118,7 +110,7 @@ PHOTOPRISM_ORIGINALS_PATH='/var/lib/photoprism/photos/Originals'
PHOTOPRISM_IMPORT_PATH='/var/lib/photoprism/photos/Import'
" > $env_path
echo -en "${GN} Creating Service file photoprism.service... "
msg_info "Creating Service"
service_path="/etc/systemd/system/photoprism.service"
echo "[Unit]
@ -136,11 +128,11 @@ ExecStop=/opt/photoprism/bin/photoprism down
[Install]
WantedBy=multi-user.target" > $service_path
systemctl enable --now photoprism &>/dev/null
echo -e "${CM}${CL} \r"
msg_ok "Created Service"
PASS=$(grep -w "root" /etc/shadow | cut -b6);
if [[ $PASS != $ ]]; then
echo -en "${GN} Customizing Container... "
msg_info "Customizing Container"
rm /etc/motd
rm /etc/update-motd.d/10-uname
touch ~/.hushlogin
@ -153,11 +145,11 @@ ExecStart=-/sbin/agetty --autologin root --noclear --keep-baud tty%I 115200,3840
EOF
systemctl daemon-reload
systemctl restart $(basename $(dirname $GETTY_OVERRIDE) | sed 's/\.d//')
echo -e "${CM}${CL} \r"
msg_ok "Customized Container"
fi
echo -en "${GN} Cleanup... "
msg_info "Cleaning up"
apt-get autoremove >/dev/null
apt-get autoclean >/dev/null
rm -rf /var/{cache,log}/* /var/lib/apt/lists/* /root/go
echo -e "${CM}${CL} \n"
rm -rf /var/{cache,log}/* /var/lib/apt/lists/*
msg_ok "Cleaned"